;*=====================================================================*/
;*    serrano/prgm/project/skribe/src/bigloo/user.scm                  */
;*    -------------------------------------------------------------    */
;*    Author      :  Manuel Serrano                                    */
;*    Creation    :  Fri Jul 25 10:02:23 2003                          */
;*    Last change :  Thu Oct  2 10:31:01 2003 (serrano)                */
;*    Copyright   :  2003 Manuel Serrano                               */
;*    -------------------------------------------------------------    */
;*    Skribe user stages                                               */
;*=====================================================================*/

;*---------------------------------------------------------------------*/
;*    The module                                                       */
;*---------------------------------------------------------------------*/
(module skribe_user
   (include "debug.sch")
   (import  skribe_types
	    skribe_eval)
   (export  (user ::obj e)
	    (user-prelude-set! ::procedure)
	    (user-postlude-set! ::procedure)
	    (user-prelude::procedure)
	    (user-postlude::procedure)))

;*---------------------------------------------------------------------*/
;*    prelude & postlude ...                                           */
;*---------------------------------------------------------------------*/
(define *user-prelude* (lambda (e) #f))
(define *user-postlude* (lambda (e) #f))

;*---------------------------------------------------------------------*/
;*    user ...                                                         */
;*---------------------------------------------------------------------*/
(define (user o e)
   (with-debug 3 'user-prelude)
   (*user-prelude* e)
   (let ((r (with-debug 3 'user o)))
      (with-debug 3 'user-postlude)
      (*user-postlude* e)
      r))

;*---------------------------------------------------------------------*/
;*    user-prelude ...                                                 */
;*---------------------------------------------------------------------*/
(define (user-prelude)
   *user-prelude*)

;*---------------------------------------------------------------------*/
;*    user-postlude ...                                                */
;*---------------------------------------------------------------------*/
(define (user-postlude)
   *user-postlude*)

;*---------------------------------------------------------------------*/
;*    user-prelude-set! ...                                            */
;*---------------------------------------------------------------------*/
(define (user-prelude-set! f)
   (if (not (and (procedure? f) (correct-arity? f 1)))
       (skribe-error 'user-prelude-set! "Illegal function" f)
       (set! *user-prelude* f)))

;*---------------------------------------------------------------------*/
;*    user-postlude-set! ...                                           */
;*---------------------------------------------------------------------*/
(define (user-postlude-set! f)
   (if (not (and (procedure? f) (correct-arity? f 1)))
       (skribe-error 'user-postlude-set! "Illegal function" f)
       (set! *user-postlude* f)))
